Bug 1815488 - python-APScheduler fails to build with Python 3.9: NoneType has no attribute...
Summary: python-APScheduler fails to build with Python 3.9: NoneType has no attribute...
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Fedora
Classification: Fedora
Component: python-APScheduler
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Fabien Boucher
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON39
TreeView+ depends on / blocked
 
Reported: 2020-03-20 12:26 UTC by Miro Hrončok
Modified: 2020-05-26 11:47 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-26 11:47:02 UTC
Type: Bug


Attachments (Terms of Use)

Description Miro Hrončok 2020-03-20 12:26:36 UTC
python-APScheduler fails to build with Python 3.9.0a4:

==================================== ERRORS ====================================
________ ERROR at teardown of TestGeventScheduler.test_add_pending_job _________
tests/test_schedulers.py:876: in start_scheduler
    scheduler.shutdown()
apscheduler/schedulers/gevent.py:27: in shutdown
    self._greenlet.join()
E   AttributeError: 'NoneType' object has no attribute 'join'
__________ ERROR at teardown of TestGeventScheduler.test_add_live_job __________
tests/test_schedulers.py:876: in start_scheduler
    scheduler.shutdown()
apscheduler/schedulers/gevent.py:27: in shutdown
    self._greenlet.join()
E   AttributeError: 'NoneType' object has no attribute 'join'
____________ ERROR at teardown of TestGeventScheduler.test_shutdown ____________
tests/test_schedulers.py:876: in start_scheduler
    scheduler.shutdown()
apscheduler/schedulers/gevent.py:27: in shutdown
    self._greenlet.join()
E   AttributeError: 'NoneType' object has no attribute 'join'
=================================== FAILURES ===================================
___________________ TestGeventScheduler.test_add_pending_job ___________________
tests/test_schedulers.py:892: in test_add_pending_job
    start_scheduler()
apscheduler/schedulers/gevent.py:22: in start
    self._greenlet = gevent.spawn(self._main_loop)
src/gevent/greenlet.py:663: in gevent._greenlet.Greenlet.spawn
    ???
E   AttributeError: type object 'method' has no attribute 'start'
____________________ TestGeventScheduler.test_add_live_job _____________________
tests/test_schedulers.py:905: in test_add_live_job
    start_scheduler()
apscheduler/schedulers/gevent.py:22: in start
    self._greenlet = gevent.spawn(self._main_loop)
src/gevent/greenlet.py:663: in gevent._greenlet.Greenlet.spawn
    ???
E   AttributeError: type object 'method' has no attribute 'start'
______________________ TestGeventScheduler.test_shutdown _______________________
tests/test_schedulers.py:919: in test_shutdown
    start_scheduler()
apscheduler/schedulers/gevent.py:22: in start
    self._greenlet = gevent.spawn(self._main_loop)
src/gevent/greenlet.py:663: in gevent._greenlet.Greenlet.spawn
    ???
E   AttributeError: type object 'method' has no attribute 'start'

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.9/fedora-rawhide-x86_64/01313409-python-APScheduler/

For all our attempts to build python-APScheduler with Python 3.9, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.9/package/python-APScheduler/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.9:
https://copr.fedorainfracloud.org/coprs/g/python/python3.9/

Let us know here if you have any questions.

Python 3.9 will be included in Fedora 33. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.9.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Miro Hrončok 2020-05-25 13:01:06 UTC
This comment is mass posted to all bugs blocking the Python 3.9 tracker, sorry if it is not 100 % relevant. When in doubt, please ask.


The Python 3.9 rebuild is in progress in a Koji side tag.

If you fix this bug, please don't rebuild the package in regular rawhide, but do it in the side tag with:

    $ fedpkg build --target=f33-python

The rebuild is progressing slowly and it is possible this package won't have all the required build dependencies yet. If that's the case, please just leave the fix committed and pushed and we will eventually rebuild it for you.

You are not asked to go and try rebuild all the missing dependencies yourself. If you know there is a bootstrap loop in the dependencies, let me know and we can untangle it together.

If you want to test your fix or reproduce the failure, you can still use the Copr repo mentioned in the initial comment of this bug: https://copr.fedorainfracloud.org/coprs/g/python/python3.9/

Comment 2 Fabien Boucher 2020-05-26 11:28:43 UTC
The package built correctly during the python3.9 mass rebuilt: https://koji.fedoraproject.org/koji/buildinfo?buildID=1512024
https://src.fedoraproject.org/rpms/python-APScheduler/c/17757f6810f6d5d63106cb108456eb581a857024?branch=master

I assume this bug could be closed.

Comment 3 Miro Hrončok 2020-05-26 11:47:02 UTC
Yes, thanks.


Note You need to log in before you can comment on or make changes to this bug.